image: python:latest

stages:
  - linting
  - test
  - deploy 

######################
## Markdown linting - TODO FIXME
#markdownlint:
#  stage: linting
#  image: registry.gitlab.com/pipeline-components/markdownlint:latest
#  script:
#    - mdl --config .markdownlint.yml .
#  allow_failure: true

# https://gitlab.com/pipeline-components/markdown-spellcheck
#markdown-spellcheck:
#  stage: linting
#  image: registry.gitlab.com/pipeline-components/markdown-spellcheck:latest
#  script:
#    - mdspell --report '**/*.md'
#  allow_failure: true

######################
# MkDocs job templates

# base installs the requirements
.mkdocs-base:
  script:
    - pip install -r requirements.txt

# build generates static site, throws errors with wrong config, etc.
.mkdocs-build:
  script:
    - mkdocs build --site-dir public

# default uses the free MkDocs Material theme
.mkdocs-default:
  script:
    - !reference [.mkdocs-base, script]
    - !reference [.mkdocs-build, script]

# insiders uses the MkDdocs Material insiders version (sponsoring by dnsmichi, token in CI/CD variables)
.mkdocs-insiders:
  script:
    - !reference [.mkdocs-base, script]
    - |
      if [ -z "${GITHUB_TOKEN_MKDOCS}" ]; then
        echo "Using MkDocs Material default"
      else
        echo "Using MkDocs Material insiders"
        pip install git+https://${GITHUB_TOKEN_MKDOCS}@github.com/squidfunk/mkdocs-material-insiders.git  
      fi
    - !reference [.mkdocs-build, script]

######################
# MkDocs jobs 

# lint mkdocs on !main branch
lint-mkdocs:
  extends: .mkdocs-default
  stage: linting
  except:
    - main

# lint and generate site on main branch 
pages:
  extends: .mkdocs-insiders
  stage: deploy
  only:
    - main
  artifacts:
    paths:
      - public
